(***************************************************************)
(* Coq code for OCAP                                           *)
(*                                                             *)
(* SCAP                                                        *)
(*                                                             *)
(*                                                             *)
(***************************************************************)

(* $Id: scap_2.v,v 1.2 2006/07/15 02:56:41 ssg05 Exp $ *)

Require Import natutil2.
Require Import scap.
Require Import extac.

Ltac psi_lookup label :=
  match goal with
    | H : CHSpec.lookup ?psi ?f (mk_cdspec ?p ?g)
      |- _ =>
        beq_nat_dec f label;
        [ substH H with (@CHSpec.lookup_get psi f _ H);
          unfold CHSpec.get, CHSpecDef.get in H;
          unfold psi in H;
          bnat_rew_all;
          beq_nat_subst f;
          simpl in H;
          (match type of H with 
             | NoneT = SomeT _  => discriminate H
             | SomeT (mk_cdspec ?p' ?g') = SomeT (mk_cdspec p g) => 
               injection H; intros H1 H2; subst
           end)
          |idtac ]
    | _ => idtac
  end.

Ltac psi_lookup_not :=
  match goal with
    | H : CHSpec.lookup ?psi ?f ?a |- _ =>
      substH H with (@CHSpec.lookup_get psi f a H);
      unfold CHSpec.get, CHSpec.get, CHSpecDef.get in H;      
      unfold psi in H; bnat_rew_all; simpl in H;
        (match type of H with
           | NoneT = SomeT _ => discriminate H
           | _ => fail
         end)
    | _ => fail
  end.
