(***************************************************************)
(* Coq code for OCAP                                           *)
(*                                                             *)
(* Typed Assembly Language                                     *)
(*                                                             *)
(* tal-0, some useful lemmas & tactics                         *)
(***************************************************************)

(* $Id: tal0_2.v,v 1.2 2006/07/15 02:56:41 ssg05 Exp $ *)

Require Import natutil2.
Require Import tal0.
Require Import extac.

Ltac psi_lookup label :=
  match goal with
    | H : CHSpec.lookup ?psi ?f ?a
      |- _ =>
      beq_nat_dec f label;
      [ substH H with (@CHSpec.lookup_get psi f a H);
        unfold CHSpec.get, CHSpec.get, CHSpecDef.get in H;
        unfold psi in H;
        bnat_rew_all;
        beq_nat_subst f;
        simpl in H;
          (match type of H with 
             | None = Some a  => discriminate H
             | Some ?b = Some a =>  inj_hyp H; subst a
           end)
        | idtac]
    | _ => idtac
  end.

Ltac psi_lookup_not :=
  match goal with
    | H : CHSpec.lookup ?psi ?f ?a |- _ =>
      substH H with (@CHSpec.lookup_get psi f a H);
      unfold CHSpec.get, CHSpec.get, CHSpecDef.get in H;      
      unfold psi in H; bnat_rew_all; simpl in H;
        (match type of H with
           | None = Some a => discriminate H
           | _ => fail
         end)
    | _ => fail
  end.
          
