(***************************************************************)
(* Coq code for OCAP                                           *)
(*                                                             *)
(* Instruction                                                 *)
(*     MIPS-style                                              *)
(*                                                             *)
(***************************************************************)

(* $Id: instr.v,v 1.4 2006/07/15 02:56:42 ssg05 Exp $ *)

Require Import reg.
Require Import word.
Require Import label.

Inductive instr : Set :=
  | addu : forall (rd : reg) (rs : reg) (rt : reg), instr
  | addiu : forall (rd : reg) (rs : reg) (w : word), instr
  | subu : forall (rd : reg) (rs : reg) (rt : reg), instr
  | subiu : forall (rd : reg) (rs : reg) (w : word), instr
  | lw : forall (rt : reg) (i : word) (rs : reg), instr
  | sw : forall (rt : reg) (i : word) (rs : reg), instr
  | blt : forall (rs : reg) (rt : reg) (f : word), instr
  | bgtz : forall (rs : reg) (f : word), instr
  | j : forall (f : word), instr
  | jr : forall (r : reg), instr.

Inductive instrseq : Set :=
  | ione : instr -> instrseq
  | iseq : instr -> instrseq -> instrseq.

Implicit Types i : instr.
