Require Import Arith.
Require Import Omega.

Lemma p0id : forall x,
  x + 0 = x.
Proof.
  intros; auto with arith.
Qed.

Lemma pm2 : forall x,
  x + 2 - 2 = x.
Proof.
  intros; omega.
Qed.

Lemma mp2 : forall x,
  x >= 2 -> x - 2 + 2 = x.
Proof.
  intros; omega.
Qed.

Lemma p2m1 : forall x,
  x + 2 - 1 = S x.
Proof.
  intros; omega.
Qed.

Lemma p1S : forall x,
  x + 1 = S x.
Proof.
  intros; omega.
Qed.

Lemma pSSp : forall x y,
  x + S y = S x + y.
Proof.
  intros; omega.
Qed.

Lemma SSm2 : forall x,
  (S (S x)) - 2 = x.
Proof.
  intros; omega.
Qed.

Lemma SSm1 : forall x,
  (S (S x)) - 1 = S x.
Proof.
  intros; omega.
Qed.

Ltac simplpm :=
  match goal with
    | [ |- context [(?x + 1)]] =>
      rewrite p1S; simplpm
    | [ |- context [(?x + 0)]] =>
      rewrite p0id; simplpm
    | _ => idtac
  end.

Ltac simplpm2 :=
  match goal with
    | [ |- context [(?x + 2 - 2)]] =>
      rewrite pm2; simplpm2
    | [ |- context [(?x - 2 + 2)]] =>
      rewrite mp2;
	[simplpm2 | auto]
    | [ |- context [(?x + 2 - 1)]] =>
      rewrite p2m1; simplpm2
    | _ => simplpm
  end.

Ltac simplpm2h H :=
  generalize H; clear H; simplpm2; intro H.
